import {
  a as s
} from "./chunk-KCGBM3WI.js";
import {
  a
} from "./chunk-JCASV5LV.js";
import {
  a as o
} from "./chunk-IO47FP3U.js";

// src/preview-errors.ts
var U = /* @__PURE__ */ ((t) => (t.BLOCKS = "BLOCKS", t.DOCS_TOOLS = "DOCS-TOOLS", t.PREVIEW_CLIENT_LOGGER = "PREVIEW_CLIENT-LOGGER", t.PREVIEW_CHANNELS = "PREVIEW_CHANNELS", t.PREVIEW_CORE_EVENTS = "PREVIEW_CORE-EVENTS", t.PREVIEW_INSTRUMENTER = "PREVIEW_INSTRUMENTER", t.PREVIEW_API = "PREVIEW_API", t.PREVIEW_REACT_DOM_SHIM = "PREVIEW_REACT-DOM-SHIM", t.PREVIEW_ROUTER = "PREVIEW_ROUTER", t.PREVIEW_THEMING = "PREVIEW_THEMING", t.RENDERER_HTML = "RENDERER_HTML", t.RENDERER_PREACT = "RENDERER_PREACT", t.RENDERER_REACT = "RENDERER_REACT", t.RENDERER_SERVER = "RENDERER_SERVER", t.RENDERER_SVELTE = "RENDERER_SVELTE", t.RENDERER_VUE = "RENDERER_VUE", t.RENDERER_VUE3 = "RENDERER_VUE3", t.RENDERER_WEB_COMPONENTS = "RENDERER_WEB-COMPONENTS", t.FRAMEWORK_NEXTJS = "FRAMEWORK_NEXTJS", t.ADDON_VITEST = "ADDON_VITEST", t.ADDON_A11Y = "ADDON_A11Y", t))(U || {}), r = class r extends s {
  constructor(e) {
    super({
      category: "PREVIEW_API",
      code: 1,
      message: a`
        Couldn't find story matching id '${e.storyId}' after HMR.
        - Did you just rename a story?
        - Did you remove it from your CSF file?
        - Are you sure a story with the id '${e.storyId}' exists?
        - Please check the values in the stories field of your main.js config and see if they would match your CSF File.
        - Also check the browser console and terminal for potential error messages.`
    });
    this.data = e;
  }
};
o(r, "MissingStoryAfterHmrError");
var k = r, i = class i extends s {
  constructor(e) {
    super({
      category: "PREVIEW_API",
      code: 2,
      documentation: "https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#using-implicit-actions-during-rendering-is-deprecated-for-example-in-the-play-function",
      message: a`
        We detected that you use an implicit action arg while ${e.phase} of your story.  
        ${e.deprecated ? `
This is deprecated and won't work in Storybook 8 anymore.
` : ""}
        Please provide an explicit spy to your args like this:
          import { fn } from 'storybook/test';
          ... 
          args: {
           ${e.name}: fn()
          }`
    });
    this.data = e;
  }
};
o(i, "ImplicitActionsDuringRendering");
var S = i, c = class c extends s {
  constructor() {
    super({
      category: "PREVIEW_API",
      code: 3,
      message: a`
        Cannot call \`storyStore.extract()\` without calling \`storyStore.cacheAllCsfFiles()\` first.

        You probably meant to call \`await preview.extract()\` which does the above for you.`
    });
  }
};
o(c, "CalledExtractOnStoreError");
var _ = c, u = class u extends s {
  constructor() {
    super({
      category: "PREVIEW_API",
      code: 4,
      message: a`
        Expected your framework's preset to export a \`renderToCanvas\` field.

        Perhaps it needs to be upgraded for Storybook 7.0?`,
      documentation: "https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#mainjs-framework-field"
    });
  }
};
o(u, "MissingRenderToCanvasError");
var N = u, d = class d extends s {
  constructor(e) {
    super({
      category: "PREVIEW_API",
      code: 5,
      message: a`
        Called \`Preview.${e.methodName}()\` before initialization.
        
        The preview needs to load the story index before most methods can be called. If you want
        to call \`${e.methodName}\`, try \`await preview.initializationPromise;\` first.
        
        If you didn't call the above code, then likely it was called by an addon that needs to
        do the above.`
    });
    this.data = e;
  }
};
o(d, "CalledPreviewMethodBeforeInitializationError");
var V = d, l = class l extends s {
  constructor(e) {
    super({
      category: "PREVIEW_API",
      code: 6,
      message: a`
        Error fetching \`/index.json\`:
        
        ${e.text}

        If you are in development, this likely indicates a problem with your Storybook process,
        check the terminal for errors.

        If you are in a deployed Storybook, there may have been an issue deploying the full Storybook
        build.`
    });
    this.data = e;
  }
};
o(l, "StoryIndexFetchError");
var A = l, p = class p extends s {
  constructor(e) {
    super({
      category: "PREVIEW_API",
      code: 7,
      message: a`
        Tried to render docs entry ${e.storyId} but it is a MDX file that has no CSF
        references, or autodocs for a CSF file that some doesn't refer to itself.
        
        This likely is an internal error in Storybook's indexing, or you've attached the
        \`attached-mdx\` tag to an MDX file that is not attached.`
    });
    this.data = e;
  }
};
o(p, "MdxFileWithNoCsfReferencesError");
var O = p, y = class y extends s {
  constructor() {
    super({
      category: "PREVIEW_API",
      code: 8,
      message: a`
        Couldn't find any stories in your Storybook.

        - Please check your stories field of your main.js config: does it match correctly?
        - Also check the browser console and terminal for error messages.`
    });
  }
};
o(y, "EmptyIndexError");
var W = y, h = class h extends s {
  constructor(e) {
    super({
      category: "PREVIEW_API",
      code: 9,
      message: a`
        Couldn't find story matching '${e.storySpecifier}'.

        - Are you sure a story with that id exists?
        - Please check your stories field of your main.js config.
        - Also check the browser console and terminal for error messages.`
    });
    this.data = e;
  }
};
o(h, "NoStoryMatchError");
var v = h, m = class m extends s {
  constructor(e) {
    super({
      category: "PREVIEW_API",
      code: 10,
      message: a`
        Couldn't find story matching id '${e.storyId}' after importing a CSF file.

        The file was indexed as if the story was there, but then after importing the file in the browser
        we didn't find the story. Possible reasons:
        - You are using a custom story indexer that is misbehaving.
        - You have a custom file loader that is removing or renaming exports.

        Please check your browser console and terminal for errors that may explain the issue.`
    });
    this.data = e;
  }
};
o(m, "MissingStoryFromCsfFileError");
var D = m, E = class E extends s {
  constructor() {
    super({
      category: "PREVIEW_API",
      code: 11,
      message: a`
        Cannot access the Story Store until the index is ready.

        It is not recommended to use methods directly on the Story Store anyway, in Storybook 9 we will
        remove access to the store entirely`
    });
  }
};
o(E, "StoryStoreAccessedBeforeInitializationError");
var C = E, g = class g extends s {
  constructor(e) {
    super({
      category: "PREVIEW_API",
      code: 12,
      message: a`
      Incorrect use of mount in the play function.
      
      To use mount in the play function, you must satisfy the following two requirements: 
      
      1. You *must* destructure the mount property from the \`context\` (the argument passed to your play function). 
         This makes sure that Storybook does not start rendering the story before the play function begins.
      
      2. Your Storybook framework or builder must be configured to transpile to ES2017 or newer. 
         This is because destructuring statements and async/await usages are otherwise transpiled away, 
         which prevents Storybook from recognizing your usage of \`mount\`.
      
      Note that Angular is not supported. As async/await is transpiled to support the zone.js polyfill. 
      
      More info: https://storybook.js.org/docs/writing-tests/interaction-testing#run-code-before-the-component-gets-rendered
      
      Received the following play function:
      ${e.playFunction}`
    });
    this.data = e;
  }
};
o(g, "MountMustBeDestructuredError");
var $ = g, R = class R extends s {
  constructor(e) {
    super({
      category: "PREVIEW_API",
      code: 14,
      message: a`
        No render function available for storyId '${e.id}'
      `
    });
    this.data = e;
  }
};
o(R, "NoRenderFunctionError");
var j = R, b = class b extends s {
  constructor() {
    super({
      category: "PREVIEW_API",
      code: 15,
      message: a`
        No component is mounted in your story.
        
        This usually occurs when you destructure mount in the play function, but forget to call it.
        
        For example:

        async play({ mount, canvasElement }) {
          // 👈 mount should be called: await mount(); 
          const canvas = within(canvasElement);
          const button = await canvas.findByRole('button');
          await userEvent.click(button);
        };

        Make sure to either remove it or call mount in your play function.
      `
    });
  }
};
o(b, "NoStoryMountedError");
var L = b, f = class f extends s {
  constructor(e) {
    super({
      category: "PREVIEW_API",
      code: 16,
      message: `Status has typeId "${e.status.typeId}" but was added to store with typeId "${e.typeId}". Full status: ${JSON.stringify(
        e.status,
        null,
        2
      )}`
    });
    this.data = e;
  }
};
o(f, "StatusTypeIdMismatchError");
var Y = f, I = class I extends s {
  constructor() {
    super({
      category: "FRAMEWORK_NEXTJS",
      code: 1,
      documentation: "https://storybook.js.org/docs/get-started/nextjs#faq",
      message: a`
      You are importing avif images, but you don't have sharp installed.

      You have to install sharp in order to use image optimization features in Next.js.
      `
    });
  }
};
o(I, "NextJsSharpError");
var G = I, x = class x extends s {
  constructor(e) {
    super({
      category: "FRAMEWORK_NEXTJS",
      code: 2,
      message: a`
        Tried to access router mocks from "${e.importType}" but they were not created yet. You might be running code in an unsupported environment.
      `
    });
    this.data = e;
  }
};
o(x, "NextjsRouterMocksNotAvailable");
var H = x, P = class P extends s {
  constructor(e) {
    super({
      category: "DOCS-TOOLS",
      code: 1,
      documentation: "https://github.com/storybookjs/storybook/issues/26606",
      message: a`
        There was a failure when generating detailed ArgTypes in ${e.language} for:
        ${JSON.stringify(e.type, null, 2)} 
        
        Storybook will fall back to use a generic type description instead.

        This type is either not supported or it is a bug in the docgen generation in Storybook.
        If you think this is a bug, please detail it as much as possible in the Github issue.
      `
    });
    this.data = e;
  }
};
o(P, "UnknownArgTypesError");
var K = P, T = class T extends s {
  constructor(e) {
    super({
      category: "ADDON_VITEST",
      code: 1,
      // TODO: Add documentation about viewports support
      // documentation: '',
      message: a`
        Encountered an unsupported value "${e.value}" when setting the viewport ${e.dimension} dimension.
        
        The Storybook plugin only supports values in the following units:
        - px, vh, vw, em, rem and %.
        
        You can either change the viewport for this story to use one of the supported units or skip the test by adding '!test' to the story's tags per https://storybook.js.org/docs/writing-stories/tags
      `
    });
    this.data = e;
  }
};
o(T, "UnsupportedViewportDimensionError");
var X = T, w = class w extends s {
  constructor() {
    super({
      category: "ADDON_A11Y",
      code: 1,
      documentation: "https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#a11y-addon-replace-element-parameter-with-context-parameter",
      message: 'The "element" parameter in parameters.a11y has been removed. Use "context" instead.'
    });
  }
};
o(w, "ElementA11yParameterError");
var F = w;

export {
  U as a,
  k as b,
  S as c,
  _ as d,
  N as e,
  V as f,
  A as g,
  O as h,
  W as i,
  v as j,
  D as k,
  C as l,
  $ as m,
  j as n,
  L as o,
  Y as p,
  G as q,
  H as r,
  K as s,
  X as t,
  F as u
};
